#include <iostream.h>
#define SC_INDEX 0x03c4
#define CRTC_INDEX 0x03d4
#define MISC_OUTPUT 0x03c2
#define SCREEN_SEG 0xa000
#define MAP_MASK 0x02
#define SCREEN_WIDTH 80

void WritePixelX(int X, int Y, int Color) {
  asm {	push    bp
	mov     bp,sp

	mov     ax,SCREEN_WIDTH
	mul     [bp+Y]
	mov     bx,[bp+X]
	shr     bx,1
	shr     bx,1
	add     bx,ax
	add     bx,[_CurrentPageBase]
	mov     ax,SCREEN_SEG
	mov     es,ax

	mov     cl,byte ptr [bp+X]
	and     cl,0x03
	mov     ax,0x0100 + MAP_MASK
	shl     ah,cl
	mov     dx,SC_INDEX
	out     dx,ax

	mov     al,byte ptr [bp+Color]
	mov     es:[bx],al

	pop     bp
  }
}


void main () {
  int c;
  asm {
	mov     ax,0x13
	int     0x10
	mov     dx,SC_INDEX
	mov     ax,0x0604
	out     dx,ax
	mov     ax,0x0100
	out     dx,ax
	mov     dx,MISC_OUTPUT
	mov     al,0x0e3
	out     dx,al
	mov     dx,SC_INDEX
	mov     ax,0x0300
	out     dx,ax
	mov     dx,CRTC_INDEX
	mov     al,0x11
	out     dx,al
	inc     dx
	in      al,dx
	and     al,0x7f
	out     dx,al
	dec     dx
	mov     ax,0x0d06
	out     dx,ax
	mov     ax,0x3e07
	out     dx,ax
	mov     ax,0x4109
	out     dx,ax
	mov     ax,0xea10
	out     dx,ax
	mov     ax,0xac11
	out     dx,ax
	mov     ax,0xdf12
	out     dx,ax
	mov     ax,0x0014
	out     dx,ax
	mov     ax,0xe715
	out     dx,ax
	mov     ax,0x0616
	out     dx,ax
	mov     ax,0xe317
	out     dx,ax
	mov     dx,SC_INDEX
	mov     ax,0x0f02
	out     dx,ax
	mov     ax,SCREEN_SEG
	mov     es,ax
	sub     di,di
	sub     ax,ax
	mov     cx,0x8000
	rep     stosw
  }
  cin >> c;
}